/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.daypc.service.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import java.sql.Timestamp;
import java.math.BigDecimal;
import java.io.Serializable;
import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import me.zhengjie.modules.dm.food.domain.DmFood;
import me.zhengjie.modules.dm.foodCate.domain.DmFoodCate;
import me.zhengjie.modules.dm.rfidTableware.domain.DmRfidTableware;

import javax.persistence.Column;

/**
* @website https://el-admin.vip
* @description /
* @author sunmz
* @date 2021-09-22
**/
@Data
public class DmDayPcDto implements Serializable {

    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long id;

    /** 菜品id */
    private Long pid;
//    private DmFood food;

    /** 餐盘id */
    private Long cpid;
//    private DmRfidTableware rfidTableware;

    /** 菜品名称 */
    private String name;

    private String state;

    private String goods;

    private String barcode;

    private String no;

    private String pinyin;

    /** 价格 */
    private BigDecimal price;

    /** 餐别 */
    private String times;

    private String qtyBook;

    /** 菜品分类id */
//    private Integer cate;
    private DmFoodCate cate;

    /** 菜品分类名称 */
    private String cateName;

    /** 档口id */
    private Integer window;

    /** 档口名称 */
    private String windowName;

    /** 菜品状态 */
    private Integer pstate;

    /** 流水号 */
    private Long seq;

    /** 日期 */
    private Timestamp date;

    /** 餐厅名称 */
    private String shopname;
}