/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.foodPj.repository;

import me.zhengjie.modules.dm.foodPj.domain.DmFoodPj;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Map;

/**
* @website https://el-admin.vip
* @author sunmz
* @date 2021-09-15
**/
public interface DmFoodPjRepository extends JpaRepository<DmFoodPj, Long>, JpaSpecificationExecutor<DmFoodPj> {

    @Query(value = " SELECT `id`, `oid`, `food_name`, `food_code`, `food_type`, `user_code`, `user_name`, `pj_type`, `order_time`, `order_bh`, `pj_time`, `pj_star`, `pj_tag`, `pj_desc`, `pj_pic` FROM  dm_food_pj AS pj where DATE_FORMAT(pj.pj_time,'%Y-%m-%d') = DATE_FORMAT(NOW(),'%Y-%m-%d') AND pj.food_code = :code  ",nativeQuery = true)
    List<Map<String,Object>> findByFoodCode(String code);
}