package me.zhengjie.modules.dm.video.service;

import me.zhengjie.domain.LocalStorage;
import me.zhengjie.modules.dm.user.service.dto.DmUserDto;
import me.zhengjie.modules.dm.user.service.dto.DmUserQueryCriteria;
import me.zhengjie.modules.dm.video.domain.DmVideo;
import me.zhengjie.modules.dm.video.service.dto.DmVideoDto;
import me.zhengjie.modules.dm.video.service.dto.DmVideoQueryCriteria;
import org.springframework.data.domain.Pageable;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import java.util.Map;

public interface DmVideoService {
    /**
     * 查询数据分页
     * @param criteria 条件
     * @param pageable 分页参数
     * @return Map<String,Object>
     */
    Map<String,Object> queryAll(DmVideoQueryCriteria criteria, Pageable pageable);

    /**
     * 查询所有数据不分页
     * @param criteria 条件参数
     * @return List<DmUserDto>
     */
    List<DmVideoDto> queryAll(DmVideoQueryCriteria criteria);

    /**
     * 新增
     * @param name 文件名称
     * @param file 文件
     * @return
     */
    DmVideo create(String name, MultipartFile file);
}
